"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.default=_default;var _isObject2=_interopRequireDefault(require("lodash/isObject"));var _buildFirestoreCommand=_interopRequireDefault(require("./buildFirestoreCommand"));var _buildRtdbCommand=_interopRequireDefault(require("./buildRtdbCommand"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};var ownKeys=Object.keys(source);if(typeof Object.getOwnPropertySymbols==="function"){ownKeys=ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym){return Object.getOwnPropertyDescriptor(source,sym).enumerable}))}ownKeys.forEach(function(key){_defineProperty(target,key,source[key])})}return target}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}function _default({Cypress,cy,firebase}){Cypress.Commands.add("login",()=>{if(!Cypress.env("FIREBASE_AUTH_JWT")){cy.log("FIREBASE_AUTH_JWT must be set to cypress environment in order to login")}else if(firebase.auth().currentUser){cy.log("Authed user already exists, login complete.")}else{return new Promise((resolve,reject)=>{firebase.auth().onAuthStateChanged(auth=>{if(auth){resolve(auth)}});firebase.auth().signInWithCustomToken(Cypress.env("FIREBASE_AUTH_JWT")).catch(reject)})}});Cypress.Commands.add("logout",()=>{cy.log("Confirming user is logged out...");if(!firebase.auth().currentUser){cy.log("Current user already logged out.")}else{cy.log("Current user exists, logging out...");firebase.auth().signOut()}});Cypress.Commands.add("callRtdb",(action,actionPath,data,opts={})=>{const dataToWrite=(0,_isObject2.default)(data)?_objectSpread({},data):data;if((0,_isObject2.default)(data)&&opts.withMeta){dataToWrite.createdBy=Cypress.env("TEST_UID");dataToWrite.createdAt=firebase.database.ServerValue.TIMESTAMP}const rtdbCommand=(0,_buildRtdbCommand.default)(Cypress,action,actionPath,dataToWrite,opts);cy.log(`Calling RTDB command:\n${rtdbCommand}`);return cy.exec(rtdbCommand).then(out=>{const _ref=out||{},stdout=_ref.stdout,stderr=_ref.stderr;if(stderr){cy.log(`Error in Firestore Command:\n${stderr}`);return Promise.reject(stderr)}if(action==="get"&&typeof stdout==="string"){try{return JSON.parse(stdout)}catch(err){cy.log("Error parsing data from callRtdb response",out);return Promise.reject(err)}}return stdout})});Cypress.Commands.add("callFirestore",(action,actionPath,data,opts={})=>{const dataToWrite=(0,_isObject2.default)(data)?_objectSpread({},data):data;if((0,_isObject2.default)(data)&&opts.withMeta){dataToWrite.createdBy=Cypress.env("TEST_UID");dataToWrite.createdAt=firebase.firestore.FieldValue.serverTimestamp()}const firestoreCommand=(0,_buildFirestoreCommand.default)(Cypress,action,actionPath,dataToWrite,opts);cy.log(`Calling Firestore command:\n${firestoreCommand}`);cy.exec(firestoreCommand,{timeout:100000}).then(out=>{const _ref2=out||{},stdout=_ref2.stdout,stderr=_ref2.stderr;if(stderr){cy.log(`Error in Firestore Command:\n${stderr}`);return Promise.reject(stderr)}if(action==="get"&&typeof stdout==="string"){try{return JSON.parse(stdout)}catch(err){cy.log("Error parsing data from callFirestore response",out);return Promise.reject(err)}}return stdout})})}module.exports=exports.default;